## root-6-16-00.tar.gz

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.6 FATAL_ERROR)

set(policy_new CMP0068 CMP0072 CMP0077)
foreach(policy ${policy_new})
  if(POLICY ${policy})
    cmake_policy(SET ${policy} NEW)
  endif()
endforeach()

include(cmake/modules/CaptureCommandLine.cmake)

project(ROOT)

#---Set the locale to default C to prevent issued due to localization of commands---------------
# This is necessary as we for example call `clang -v` and parse its output. But on a localized
# program, the output parsing is much more error prone as certrain strings we're looking for
# could be missing or be in a different order. To prevent those errors, let's just force all
# output to use the default C locale which is more or less identical on all systems.
set(ENV{LANG} C)

#---Set pathes where to put the libraries, executables and headers------------------------------
set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_ARCHIVE_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/lib)
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${CMAKE_BINARY_DIR}/bin)

# Before setting ROOTSYS, make sure that the environment isn't polluted by a different
# ROOT build. This is significant e,g. for roottest, which will otherwise have libraries
# of a different ROOT build available / visible / reachable.
if($ENV{ROOTSYS})
  string(REPLACE "$ENV{ROOTSYS}/bin" "" ENV{PATH}, $ENV{PATH})
  string(REPLACE "$ENV{ROOTSYS}/lib" "" ENV{LD_LIBRARY_PATH} $ENV{LD_LIBRARY_PATH})
  string(REPLACE "$ENV{ROOTSYS}/lib" "" ENV{PYTHONPATH} $ENV{PYTHONPATH})
  set(ENV{"ROOTSYS"} ${CMAKE_BINARY_DIR})
endif()

set(ROOTSYS ${CMAKE_BINARY_DIR})
set(HEADER_OUTPUT_PATH ${CMAKE_BINARY_DIR}/include)
set(ROOT_INCLUDE_DIR ${HEADER_OUTPUT_PATH})

#---Set the ROOT version--------------------------------------------------------------------
find_package(Git)
if(Git_FOUND AND EXISTS ${CMAKE_SOURCE_DIR}/.git)
  execute_process(COMMAND ${GIT_EXECUTABLE} --git-dir=${CMAKE_SOURCE_DIR}/.git describe --all
                  OUTPUT_VARIABLE GIT_DESCRIBE_ALL
                  RESULT_VARIABLE GIT_DESCRIBE_ERRCODE
                  ERROR_QUIET
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
else()
  set(GIT_DESCRIBE_ERRCODE "NoGit")
endif()

function(SET_VERSION_FROM_FILE)
  file(READ ${CMAKE_SOURCE_DIR}/build/version_number versionstr)
  string(STRIP ${versionstr} versionstr)
  string(REGEX REPLACE "([0-9]+)[.][0-9]+[/][0-9]+" "\\1" ROOT_MAJOR_VERSION ${versionstr})
  string(REGEX REPLACE "[0-9]+[.]([0-9]+)[/][0-9]+" "\\1" ROOT_MINOR_VERSION ${versionstr})
  string(REGEX REPLACE "[0-9]+[.][0-9]+[/]([0-9]+)" "\\1" ROOT_PATCH_VERSION ${versionstr})
  set(ROOT_VERSION "${ROOT_MAJOR_VERSION}.${ROOT_MINOR_VERSION}.${ROOT_PATCH_VERSION}" PARENT_SCOPE)
  set(ROOT_MAJOR_VERSION "${ROOT_MAJOR_VERSION}" PARENT_SCOPE)
  set(ROOT_MINOR_VERSION "${ROOT_MINOR_VERSION}" PARENT_SCOPE)
  set(ROOT_PATCH_VERSION "${ROOT_PATCH_VERSION}" PARENT_SCOPE)
endfunction()

if(GIT_DESCRIBE_ERRCODE)
  SET_VERSION_FROM_FILE()
else()
  execute_process(COMMAND ${GIT_EXECUTABLE} --git-dir=${CMAKE_SOURCE_DIR}/.git describe --always
                  OUTPUT_VARIABLE GIT_DESCRIBE_ALWAYS
                  ERROR_QUIET
                  OUTPUT_STRIP_TRAILING_WHITESPACE)
  string(TIMESTAMP GIT_TIMESTAMP "%b %d %Y, %H:%M:%S" UTC)

  string(REGEX REPLACE "^v([0-9])-([0-9]+)-" "\\1.\\2." ROOT_VERSION "${GIT_DESCRIBE_ALWAYS}")
  if("${GIT_DESCRIBE_ALL}" MATCHES "^tags/v[0-9]+-[0-9]+-[0-9]+.*")
    # GIT_DESCRIBE_ALWAYS: v6-16-00-rc1
    # GIT_DESCRIBE_ALL: tags/v6-16-00-rc1
    # tag might end on "-rc1" or similar; parse version number in front.
    string(REGEX REPLACE "v([0-9]+)-.*" "\\1" ROOT_MAJOR_VERSION ${GIT_DESCRIBE_ALWAYS})
    string(REGEX REPLACE "v[0-9]+-([0-9]+).*" "\\1" ROOT_MINOR_VERSION ${GIT_DESCRIBE_ALWAYS})
    string(REGEX REPLACE "v[0-9]+-[0-9]+-([0-9]+).*" "\\1" ROOT_PATCH_VERSION ${GIT_DESCRIBE_ALWAYS})
  elseif("${GIT_DESCRIBE_ALL}" MATCHES "/v[0-9]+-[0-9]+.*-patches$")
    # GIT_DESCRIBE_ALWAYS: v6-16-00-rc1-47-g9ba56ef4a3
    # GIT_DESCRIBE_ALL: heads/v6-16-00-patches
    string(REGEX REPLACE "^.*/v([0-9]+)-.*" "\\1" ROOT_MAJOR_VERSION ${GIT_DESCRIBE_ALL})
    string(REGEX REPLACE "^.*/v[0-9]+-([0-9]+).*" "\\1" ROOT_MINOR_VERSION ${GIT_DESCRIBE_ALL})
    set(ROOT_PATCH_VERSION "99") # aka head of ...-patches
  else()
    # GIT_DESCRIBE_ALWAYS: v6-13-04-2163-g7e8d27ea66
    # GIT_DESCRIBE_ALL: heads/master or remotes/origin/master
    SET_VERSION_FROM_FILE()
  endif()
endif()


#---Where to look first for cmake modules, before ${CMAKE_ROOT}/Modules/ is checked-------------
set(CMAKE_MODULE_PATH ${CMAKE_SOURCE_DIR}/cmake/modules)

#---Enable Folders in IDE like Visual Studio----------------------------------------------------
set_property(GLOBAL PROPERTY USE_FOLDERS ON)

#---Load some basic macros which are needed later for the confiuration and build----------------
include(RootBuildOptions)
include(RootNewMacros)
include(CheckCompiler)

#---Enable CCache ------------------------------------------------------------------------------
if(ccache)
  find_program(CCACHE_COMMAND NAMES ccache ccache-swig)
  mark_as_advanced(CCACHE_COMMAND ${CCACHE_COMMAND})

  if(EXISTS ${CCACHE_COMMAND})
    message(STATUS "Found ccache: ${CCACHE_COMMAND}")
    set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE ${CCACHE_COMMAND})
    execute_process(COMMAND ${CCACHE_COMMAND} "-V" OUTPUT_VARIABLE CCACHE_VERSION)
    string(REGEX REPLACE "ccache version ([0-9\\.]+).*" "\\1" CCACHE_VERSION ${CCACHE_VERSION})
  else()
    message(STATUS "Could NOT find ccache")
    set(ccache OFF CACHE BOOL "Use ccache (disabled since ccache was not found)" FORCE)
  endif()
endif()

#---Enable test coverage -----------------------------------------------------------------------
if(coverage)
  set(GCC_COVERAGE_COMPILE_FLAGS "-fprofile-arcs -ftest-coverage")
  set(GCC_COVERAGE_LINK_FLAGS    "-fprofile-arcs")
  set(CMAKE_CXX_FLAGS            "${CMAKE_CXX_FLAGS} ${GCC_COVERAGE_COMPILE_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS     "${CMAKE_EXE_LINKER_FLAGS} ${GCC_COVERAGE_LINK_FLAGS}")
  set(CMAKE_SHARED_LINKER_FLAGS  "${CMAKE_SHAREDLINKER_FLAGS} ${GCC_COVERAGE_LINK_FLAGS}")
  set(CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS "${CMAKE_SHARED_LIBRARY_CREATE_CXX_FLAGS} ${GCC_COVERAGE_COMPILE_FLAGS}")
endif()

#--- Enable build timing -----------------------------------------------------------------------
if (build_timing)
  # FIXME: This currently will override the use of ccache if -Dbuild_timing=On -Dccache=On is passed.
  set_property(GLOBAL PROPERTY RULE_LAUNCH_COMPILE "${CMAKE_COMMAND} -E time")
  set_property(GLOBAL PROPERTY RULE_LAUNCH_LINK "${CMAKE_COMMAND} -E time")
  #set_property(GLOBAL PROPERTY RULE_LAUNCH_CUSTOM "${CMAKE_COMMAND} -E time") 
endif()

#---Enable CTest package -----------------------------------------------------------------------
#include(CTest)
if(testing)
  enable_testing()
endif()

#---Check if the user wants to build the project in the source directory------------------------
ROOT_CHECK_OUT_OF_SOURCE_BUILD()

#---Here we look for installed software and switch on and of the different build options--------
include(SearchInstalledSoftware)
ROOT_SHOW_ENABLED_OPTIONS()

#---Here we add tcmalloc to the linker flags if needed------------------------------------------
if (TCMALLOC_FOUND)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -ltcmalloc -L${TCMALLOC_LIBRARY_PATH}")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ltcmalloc -L${TCMALLOC_LIBRARY_PATH}")
endif()

#---Here we add jemalloc to the linker flags if needed------------------------------------------
if (JEMALLOC_FOUND)
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} -ljemalloc -L${JEMALLOC_LIBRARY_PATH}")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} -ljemalloc -L${JEMALLOC_LIBRARY_PATH}")
endif()

#---Populate the configure arguments returned by 'root-config --config'-------------------------
get_cmake_property(variables CACHE_VARIABLES)
foreach(var ${variables})
  if((var MATCHES "_(LIBRARIES|LIBRARY|INCLUDE)") AND
     (NOT ${${var}} STREQUAL "") AND
     (NOT ${var} MATCHES "NOTFOUND"))
    if (var MATCHES "^QT_")
      # filter out the very long list of Qt libraries and include dirs
      if (var MATCHES "(QT_LIBRARY_DIR|QT_QTCORE_INCLUDE_DIR)")
        set(ROOT_CONFIGARGS "${ROOT_CONFIGARGS}${var}=${${var}} ")
      endif()
    else()
      if ((NOT var MATCHES "_(DOCS|TESTS|INSTALL)") AND (NOT var MATCHES "^_"))
        set(ROOT_CONFIGARGS "${ROOT_CONFIGARGS}${var}=${${var}} ")
      endif()
    endif()
  endif()
endforeach()

#---Move (copy) directories to binary tree------------------------------------------------------
set(stamp_file ${CMAKE_CURRENT_BINARY_DIR}${CMAKE_FILES_DIRECTORY}/move_artifacts.stamp)
add_custom_command(OUTPUT ${stamp_file}
                   COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/LICENSE ${CMAKE_BINARY_DIR}/LICENSE
                   COMMAND ${CMAKE_COMMAND} -E copy_directory ${CMAKE_SOURCE_DIR}/README ${CMAKE_BINARY_DIR}/README
                   COMMAND ${CMAKE_COMMAND} -E touch ${stamp_file}
                   COMMENT "Copying directories such as etc, icons, fonts, etc. to build area")

#---Copy files to the build area, with dependency---------------------------------
file(GLOB_RECURSE artifact_files RELATIVE ${CMAKE_SOURCE_DIR} tutorials/* etc/* test/* icons/* fonts/* macros/*)
set(artifact_files_builddir)
foreach(artifact_file ${artifact_files})
  # Filter out hsimple.root; someone might have created it in the src dir, and the hsimple.root
  # target below will interfere.
  if (NOT (artifact_file STREQUAL "tutorials/hsimple.root"))
    add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/${artifact_file}
      COMMAND ${CMAKE_COMMAND} -E copy ${CMAKE_SOURCE_DIR}/${artifact_file} ${CMAKE_BINARY_DIR}/${artifact_file}
      COMMENT "Copying ${CMAKE_SOURCE_DIR}/${artifact_file}"
      DEPENDS ${CMAKE_SOURCE_DIR}/${artifact_file})
    list(APPEND artifact_files_builddir ${CMAKE_BINARY_DIR}/${artifact_file})
  endif()
endforeach()
add_custom_target(move_artifacts DEPENDS ${stamp_file} ${artifact_files_builddir})

add_subdirectory (interpreter)
# Add the compilation flags from LLVM to the flags we use to compile cling-based tools.
set(CLING_CXXFLAGS "${CLING_CXXFLAGS} ${ROOT_LLVM_FLAGS}")

#---CXX MODULES-----------------------------------------------------------------------------------
if(cxxmodules)
  # Copy-pasted from HandleLLVMOptions.cmake, please keep up to date.
  set(OLD_CMAKE_REQUIRED_FLAGS ${CMAKE_REQUIRED_FLAGS})
  set(CMAKE_REQUIRED_FLAGS "${CMAKE_REQUIRED_FLAGS} -fmodules -fcxx-modules")
  # Check that we can build code with modules enabled, and that repeatedly
  # including <cassert> still manages to respect NDEBUG properly.
  CHECK_CXX_SOURCE_COMPILES("#undef NDEBUG
                             #include <cassert>
                             #define NDEBUG
                             #include <cassert>
                             int main() { assert(this code is not compiled); }"
                             CXX_SUPPORTS_MODULES)
  set(CMAKE_REQUIRED_FLAGS ${OLD_CMAKE_REQUIRED_FLAGS})
  if(NOT CXX_SUPPORTS_MODULES)
    message(FATAL_ERROR "cxxmodules is not supported by this compiler")
  endif()

  set(ROOT_CXXMODULES_COMMONFLAGS "${ROOT_CXXMODULES_COMMONFLAGS} -fmodules -fmodules-cache-path=${CMAKE_BINARY_DIR}/include/pcms/ -Xclang -fno-validate-pch -fno-autolink -fdiagnostics-show-note-include-stack")

  # FIXME: We should remove this once libc++ supports -fmodules-local-submodule-visibility.
  if (APPLE)
    # FIXME: TGLIncludes and alike depend on glew.h doing special preprocessor
    # trickery to override the contents of system's OpenGL.
    # On OSX #include TGLIncludes.h will trigger the creation of the system
    # OpenGL.pcm. Once it is built, glew cannot use preprocessor trickery to 'fix'
    # the translation units which it needs to 'rewrite'. The translation units
    # which need glew support are in graf3d. However, depending on the modulemap

=== bindings/CMakeLists.txt ===
if(python)
  if(NOT pyroot_experimental)
    add_subdirectory(pyroot)
  else()
    add_subdirectory(pyroot_experimental)
  endif()
endif()
if(ruby)
  add_subdirectory(ruby)
endif()
if(r)
  add_subdirectory(r)
endif()

=== core/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT (global) core package
############################################################################

add_subdirectory(clib)
add_subdirectory(clingutils)
add_subdirectory(cont)
add_subdirectory(dictgen)
add_subdirectory(foundation)
add_subdirectory(meta)
add_subdirectory(metacling)
if(NOT WIN32)
add_subdirectory(multiproc)
endif()
add_subdirectory(rint)
add_subdirectory(textinput)
add_subdirectory(thread)
add_subdirectory(imt)
add_subdirectory(zip)
add_subdirectory(lzma)
add_subdirectory(lz4)

if(NOT WIN32)
  add_subdirectory(newdelete)
endif()

if(UNIX)
  add_subdirectory(unix)
  set(unix_objects $<TARGET_OBJECTS:Unix>)
  set(dict_opts -DSYSTEM_TYPE_unix ${dict_opts})
endif()
if(WIN32)
  add_subdirectory(winnt)
  set(winnt_objects $<TARGET_OBJECTS:Winnt>)
  set(dict_opts -DSYSTEM_TYPE_winnt ${dict_opts})
endif()
if(cocoa)
  add_subdirectory(macosx)
  set(macosx_objects $<TARGET_OBJECTS:Macosx>)
  set(dict_opts -DSYSTEM_TYPE_macosx ${dict_opts})
endif()

set(CORE_OS_DICT_CXX_FLAGS ${dict_opts} PARENT_SCOPE)

# Must come after the OS specific subdirs:
add_subdirectory(base)

set(objectlibs $<TARGET_OBJECTS:Base>
               $<TARGET_OBJECTS:Clib>
               $<TARGET_OBJECTS:Cont>
               $<TARGET_OBJECTS:Foundation>
               $<TARGET_OBJECTS:Lzma>
               $<TARGET_OBJECTS:Lz4>
               $<TARGET_OBJECTS:Zip>
               $<TARGET_OBJECTS:Meta>
               $<TARGET_OBJECTS:TextInput>
               ${macosx_objects}
               ${unix_objects}
               ${winnt_objects})

#---Generation of RGitCommit.h-----------------------------------------------------------
foreach(exp ${objectlibs})
  string(REGEX REPLACE "^[$]<TARGET_OBJECTS:(.+)>" "\\1" lib ${exp})
  get_target_property(objs ${lib} OBJECTS)
  list(APPEND dep_objects ${objs})
  list(APPEND dep_targets ${lib})
endforeach()

add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/include/RGitCommit.h
                   COMMAND ${CMAKE_COMMAND} -E copy_if_different ${CMAKE_BINARY_DIR}/RGitCommit.h.tmp ${CMAKE_BINARY_DIR}/include/RGitCommit.h
                   COMMENT ""
                   DEPENDS ${CMAKE_BINARY_DIR}/RGitCommit.h.tmp
                   WORKING_DIRECTORY ${CMAKE_BINARY_DIR})

message("Recording the git revision now")

file(WRITE ${CMAKE_BINARY_DIR}/etc/gitinfo.txt
     "${GIT_DESCRIBE_ALL}
${GIT_DESCRIBE_ALWAYS}
${GIT_TIMESTAMP}
"
    )

file(WRITE ${CMAKE_BINARY_DIR}/RGitCommit.h.tmp
     "#ifndef ROOT_RGITCOMMIT_H
#define ROOT_RGITCOMMIT_H
#define ROOT_GIT_BRANCH \"${GIT_DESCRIBE_ALL}\"
#define ROOT_GIT_COMMIT \"${GIT_DESCRIBE_ALWAYS}\"
#endif
"
    )

add_custom_target(gitcommit ALL DEPENDS ${CMAKE_BINARY_DIR}/RGitCommit.h.tmp)
set_source_files_properties(${CMAKE_BINARY_DIR}/RGitCommit.h.tmp PROPERTIES GENERATED TRUE)
add_dependencies(gitcommit ${dep_targets})

set_source_files_properties(${CMAKE_BINARY_DIR}/include/RGitCommit.h
                            PROPERTIES GENERATED TRUE HEADER_FILE_ONLY TRUE)

ROOT_OBJECT_LIBRARY(BaseTROOT ${CMAKE_SOURCE_DIR}/core/base/src/TROOT.cxx ${CMAKE_BINARY_DIR}/include/RGitCommit.h)
add_dependencies(BaseTROOT gitcommit)
install(FILES ${CMAKE_BINARY_DIR}/include/RGitCommit.h DESTINATION ${CMAKE_INSTALL_INCLUDEDIR})
#----------------------------------------------------------------------------------------

if(WIN32)
  set(corelinklibs shell32.lib WSock32.lib Oleaut32.lib Iphlpapi.lib)
elseif(APPLE)
  if(cocoa)
     set(corelinklibs "-framework Cocoa -F/System/Library/PrivateFrameworks -framework CoreSymbolication")
  else()
     set(corelinklibs "-F/System/Library/PrivateFrameworks -framework CoreSymbolication")
  endif()
endif()

add_subdirectory(rootcling_stage1)

#-------------------------------------------------------------------------------
ROOT_LINKER_LIBRARY(Core
                    $<TARGET_OBJECTS:BaseTROOT>
                    ${objectlibs}
                    LIBRARIES ${PCRE_LIBRARIES} ${LZMA_LIBRARIES} xxHash::xxHash LZ4::LZ4 ZLIB::ZLIB
                              ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT} ${corelinklibs}
                    BUILTINS PCRE LZMA)

if(cling)
  add_dependencies(Core CLING)
endif()

#----------------------------------------------------------------------------------------

=== graf3d/CMakeLists.txt ===
if(cxxmodules AND APPLE)
  # FIXME: Any header of graf3d can trigger building of the OSX OpenGL module.
  # It looks like our glew infrastructure combined with the OpenGL modulemap
  # cannot be compiled with -fmodules-local-submodule-visibility yet.
  # Strip out that flag.
  string(REPLACE "-Xclang -fmodules-local-submodule-visibility" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
endif()

add_subdirectory(g3d) # special CMakeLists.txt
if(NOT WIN32 AND x11)
  add_subdirectory(x3d) # special CMakeLists.txt
endif()
if (opengl)
   add_subdirectory(eve) # special CMakeLists.txt
   add_subdirectory(gl) # special CMakeLists.txt
   if(builtin_glew)
      add_subdirectory(glew)
   endif()
   if(builtin_ftgl)
      add_subdirectory(ftgl)
   endif()
  add_subdirectory(gviz3d) # special CMakeLists.txt
endif()

if(root7)
  add_subdirectory(eve7) # special CMakeLists.txt
endif()

=== gui/CMakeLists.txt ===
add_subdirectory(gui)
add_subdirectory(ged)
add_subdirectory(fitpanel)
add_subdirectory(guibuilder)
add_subdirectory(guihtml)
add_subdirectory(recorder)
add_subdirectory(sessionviewer)

if(cxx14 OR cxx17 OR root7)
   add_subdirectory(webdisplay)
   if(cefweb)
      add_subdirectory(cefdisplay)
   endif()
   if(qt5web)
      add_subdirectory(qt5webdisplay)
   endif()
   add_subdirectory(webgui6)
endif()

if(root7)
  add_subdirectory(canvaspainter)
  add_subdirectory(fitpanelv7)
endif()
if(qtgsi)
  add_subdirectory(qtgsi)
endif()
if(qt)
  add_subdirectory(qtroot)
endif()

=== interpreter/CMakeLists.txt ===
#--- Check if we need to build llvm and clang ------------------------------------------------------
if (NOT builtin_clang)
  message(WARNING "Due to ROOT-specific patches you need a special version of clang. You cannot use vanilla clang.")
endif()

#---Define the way we want to build and what of llvm/clang/cling------------------------------------
set(LLVM_ENABLE_WARNINGS OFF CACHE BOOL "")
set(LLVM_INCLUDE_TESTS OFF CACHE BOOL "")
set(CLANG_INCLUDE_TESTS OFF CACHE BOOL "")
set(LLVM_INCLUDE_EXAMPLES OFF CACHE BOOL "")
set(CLANG_BUILD_TOOLS OFF CACHE BOOL "")
# It looks like that turning off CLANG_BUILD_TOOLS is not enough.
set(CLANG_TOOL_ARCMT_TEST_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_CLANG_CHECK_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_CLANG_FORMAT_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_CLANG_FORMAT_VS_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_CLANG_FUZZER_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_CLANG_IMPORT_TEST_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_CLANG_OFFLOAD_BUNDLER_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_CLANG_RENAME_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_C_ARCMT_TEST_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_C_INDEX_TEST_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_DIAGTOOL_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_LIBCLANG_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_SCAN_BUILD_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_SCAN_VIEW_BUILD OFF CACHE BOOL "")
set(LLVM_BUILD_TOOLS OFF CACHE BOOL "")
set(LLVM_TOOL_LLVM_AR_BUILD OFF CACHE BOOL "")
set(CLANG_TOOL_CLANG_OFFLOAD_BUNDLER_BUILD OFF CACHE BOOL "")
set(LLVM_FORCE_USE_OLD_TOOLCHAIN ON CACHE BOOL "")

# FIXME: We cannot use etcdir or prefix from RootConfiguration.cmake because it
# is included very late.
if(gnuinstall)
  set(prefix ${CMAKE_INSTALL_PREFIX})
else()
  set(prefix ${ROOTSYS})
endif()
if(IS_ABSOLUTE ${CMAKE_INSTALL_SYSCONFDIR})
  set(etcdir ${CMAKE_INSTALL_SYSCONFDIR})
else()
  set(etcdir ${prefix}/${CMAKE_INSTALL_SYSCONFDIR})
endif()
set(CLING_PLUGIN_INSTALL_PREFIX "${etcdir}/cling/plugins/" CACHE STRING "" FORCE)
set(LLVM_DIR "${CMAKE_BINARY_DIR}/interpreter/llvm/src")
if (clad)
  set(CLING_BUILD_PLUGINS ON)
endif()
set(LLVM_EXTERNAL_CLING_SOURCE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/cling" CACHE STRING "")
set(LLVM_EXTERNAL_PROJECTS "cling" CACHE STRING "")
# We only use llvm/clang through TCling which is (with the help of core/meta) already taking a lock
# to serialize access to llvm.  We can later review how to make this finer grained by using llvm's own locking
# mechanism.
set(LLVM_ENABLE_THREADS OFF CACHE BOOL "")
if(cxx17)
  set(LLVM_ENABLE_CXX1Z ON CACHE BOOL "" FORCE)
elseif(cxx14)
  set(LLVM_ENABLE_CXX1Y ON CACHE BOOL "" FORCE)
endif()

# The llvm::ReverseIterate<bool>::value symbol from llvm's SmallPtrSet.h
# somehow lands in our cling libraries on OS X and doesn't get hidden
# by visibility-inlines-hidden, so we suddenly have a global weak symbol
# from LLVM in cling which our visiblity=hidden compiled LLVM libraries
# reference. This is triggering some build system warnings like this:
#   ld: warning: direct access in function '(anonymous namespace)::NewGVN::runGVN()'
#   from file 'interpreter/llvm/src/lib/libLLVMScalarOpts.a(NewGVN.cpp.o)' to global weak symbol
#   'llvm::ReverseIterate<bool>::value' from file 'interpreter/llvm/src/lib/libclingUtils.a(AST.cpp.o)'
#   means the weak symbol cannot be overridden at runtime. This was likely caused by different
#   translation units being compiled with different visibility settings.
# There is no apparent reason why this is happening and it looks like a compiler bug,
# so let's just disable the part of the code that provides this symbol.
# As it's in the validation part of LLVM and not in something that providing functionality,
# this shouldn't cause any problems.
# TODO: We maybe can remove this code once we upgrade to LLVM>=6.0 as this symbol
# was introduced quite recently into LLVM 5.0 and probably is also causing problems
# for some other projects.
set(LLVM_ENABLE_ABI_BREAKING_CHECKS OFF CACHE BOOL "" FORCE)
set(LLVM_ABI_BREAKING_CHECKS FORCE_OFF CACHE BOOL "" FORCE)

set(CMAKE_REQUIRED_QUIET 1)  # Make the configuration of LLVM quiet

if(ROOT_ARCHITECTURE MATCHES linuxarm64)
  set(ROOT_CLING_TARGET "AArch64")
elseif(ROOT_ARCHITECTURE MATCHES linuxarm)
  set(ROOT_CLING_TARGET "ARM")
elseif(ROOT_ARCHITECTURE MATCHES linuxppc64gcc)
  set(ROOT_CLING_TARGET "PowerPC")
elseif(ROOT_ARCHITECTURE MATCHES linuxs390)
  set(ROOT_CLING_TARGET "SystemZ")
elseif(ROOT_ARCHITECTURE MATCHES linux)
  set(ROOT_CLING_TARGET "X86")
elseif(ROOT_ARCHITECTURE MATCHES macosx)
  set(ROOT_CLING_TARGET "X86")
elseif(ROOT_ARCHITECTURE MATCHES win32)
  set(ROOT_CLING_TARGET "X86")
else()
  set(ROOT_CLING_TARGET "all")
endif()

if(MSVC)
  # replace dashes in the -EH* and -GR* flags with slashes (/EH* /GR*)
  string(REPLACE " -EH" " /EH" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  string(REPLACE " -GR" " /GR" CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS}")
  set(CMAKE_EXE_LINKER_FLAGS "${CMAKE_EXE_LINKER_FLAGS} /ignore:4049,4206,4217,4221")
  set(CMAKE_SHARED_LINKER_FLAGS "${CMAKE_SHARED_LINKER_FLAGS} /ignore:4049,4206,4217,4221")
  set(CMAKE_MODULE_LINKER_FLAGS "${CMAKE_MODULE_LINKER_FLAGS} /ignore:4049,4206,4217,4221")
endif()

set(LLVM_TARGETS_TO_BUILD ${ROOT_CLING_TARGET} CACHE STRING "Semicolon-separated list of targets to build, or \"all\".")

if(clingtest)
  message("-- cling test suite enabled: llvm / clang symbols in libCling will be visible!")
  set(CLING_INCLUDE_TESTS ON CACHE BOOL "" FORCE)
  # The path to cling passed through environment variable only relevant when building
  # against external llvm. In that case, cling's testsuite cannot deduce the binary
  # of cling relatively to the llvm tools folder.
  if (NOT builtin_llvm)
    set(CLINGTEST_EXECUTABLE CLING=${CMAKE_CURRENT_BINARY_DIR}/llvm/src/${CMAKE_CFG_INTDIR}/bin/cling)
  endif()
  ROOT_ADD_TEST(clingtest-check-cling COMMAND ${CMAKE_COMMAND} --build ${CMAKE_BINARY_DIR} --target check-cling
                                       ENVIRONMENT ${CLINGTEST_EXECUTABLE})
else()
  #---Build LLVM/Clang with symbol visibility=hidden--------------------------------------------------
  ROOT_ADD_CXX_FLAG(CMAKE_CXX_FLAGS -fvisibility=hidden)
  set(CLANG_ENABLE_COMPILER OFF CACHE BOOL "")
endif()

#--- Build LLVM/Clang with modules -----------------------------------------------------------------
if(cxxmodules)
  # LLVM knows how to configure its modules builds. We cannot just add the flags
  # because the cxxmodules builds in llvm have different build dependency order.
  string(REPLACE "${ROOT_CXXMODULES_CXXFLAGS}" "" CMAKE_CXX_FLAGS ${CMAKE_CXX_FLAGS})
  string(REPLACE "${ROOT_CXXMODULES_CFLAGS}" "" CMAKE_C_FLAGS ${CMAKE_C_FLAGS})
  if(libcxx)
    # FIXME: We cannot build LLVM/clang with modules on with libstdc++, yet.
    # FIXME: We cannot build LLVM/clang with modules on with libc++, too.
    #set (LLVM_ENABLE_MODULES ON CACHE BOOL "Override the default LLVM_ENABLE_MODULES option value." )
  endif(libcxx)
endif(cxxmodules)

if(gcctoolchain)
  ROOT_ADD_CXX_FLAG(CMAKE_CXX_FLAGS --gcc-toolchain=${gcctoolchain})
endif()

#---Build type--------------------------------------------------------------------------------------
if(NOT DEFINED LLVM_BUILD_TYPE)
  set(LLVM_BUILD_TYPE Release CACHE STRING "Build type for LLVM (used to set CMAKE_BUILD_TYPE)")
endif()
if( CMAKE_BUILD_TYPE STREQUAL "Debug" AND NOT LLVM_BUILD_TYPE STREQUAL "Debug")
  message(STATUS "Selected a 'Debug' build (CMAKE_BUILD_TYPE), be aware that the embedded LLVM will still be built as 'Release'."
                 " Use the variable LLVM_BUILD_TYPE to control it.")
endif()
if(CMAKE_BUILD_TYPE STREQUAL "Debug")
  set(LLVM_ENABLE_ASSERTIONS "YES")
else()
  if(LLVM_BUILD_TYPE STREQUAL "Debug")
    set(LLVM_ENABLE_ASSERTIONS "YES")
  else()
    set(LLVM_ENABLE_ASSERTIONS "NO")
  endif()
endif()
set(CMAKE_BUILD_TYPE ${LLVM_BUILD_TYPE})
set(BUILD_SHARED_LIBS "NO")

set(CLANG_ENABLE_STATIC_ANALYZER OFF CACHE BOOL "")
set(CLANG_ENABLE_ARCMT OFF CACHE BOOL "")
set(CLANG_ENABLE_FORMAT OFF CACHE BOOL "")

#---Remove the inherited include_directories()
set_directory_properties(PROPERTIES INCLUDE_DIRECTORIES "")

#---Disable VCS writing to prevent that we always have to rebuild when someone touched the git HEAD
set(LLVM_APPEND_VC_REV OFF CACHE BOOL "Disabled LLVM revision dependency" FORCE)

#---Add the sub-directory excluding all the targets from all-----------------------------------------
if(builtin_llvm)
  if(CMAKE_GENERATOR MATCHES "Xcode")
    add_subdirectory(llvm/src)
  else()
    add_subdirectory(llvm/src EXCLUDE_FROM_ALL)
  endif()

  #---Make LLVM compilation flags public---------------------------------------------------------------
  # Extract the compilation flags from LLVM and make them public to the
  # rest of ROOT so that we can compile against LLVM with matching flags.

  # LLVM doesn't really give us a API to get this with an in-source build
  # so we just use the normal way of doing this and read the llvm directory
  # compilation properties.
  get_directory_property(LLVM_DEFS DIRECTORY llvm/src COMPILE_DEFINITIONS)
  # Turns DEFINE1;DEFINE2 to -DDEFINE1 -DDEFINE2
  string (REPLACE ";" " -D" LLVM_DEFS ";${LLVM_DEFS}")
  # CACHE variable that contains the additional flags that LLVM needs.
  set(ROOT_LLVM_FLAGS "${LLVM_DEFS}" CACHE STRING "" FORCE)
else()
  # Rely on llvm-config.
  set(CONFIG_OUTPUT)
  find_program(LLVM_CONFIG NAMES "llvm-config-5.0" "llvm-config")
  if(LLVM_CONFIG)
    message(STATUS "Found LLVM_CONFIG as ${LLVM_CONFIG}")
    set(CONFIG_COMMAND ${LLVM_CONFIG}
      "--assertion-mode"
      "--bindir"
      "--libdir"
      "--includedir"
      "--prefix"
      "--src-root"
      "--cmakedir")
    execute_process(
      COMMAND ${CONFIG_COMMAND}
      RESULT_VARIABLE HAD_ERROR
      OUTPUT_VARIABLE CONFIG_OUTPUT
    )
    if(NOT HAD_ERROR)
      string(REGEX REPLACE
        "[ \t]*[\r\n]+[ \t]*" ";"
        CONFIG_OUTPUT ${CONFIG_OUTPUT})
    else()
      string(REPLACE ";" " " CONFIG_COMMAND_STR "${CONFIG_COMMAND}")
      message(STATUS "${CONFIG_COMMAND_STR}")
      message(FATAL_ERROR "llvm-config failed with status ${HAD_ERROR}")
    endif()
  else()
    message(FATAL_ERROR "llvm-config not found -- ${LLVM_CONFIG}")
  endif()

  list(GET CONFIG_OUTPUT 0 ENABLE_ASSERTIONS)
  list(GET CONFIG_OUTPUT 1 TOOLS_BINARY_DIR)
  list(GET CONFIG_OUTPUT 2 LIBRARY_DIR)
  list(GET CONFIG_OUTPUT 3 INCLUDE_DIR)
  list(GET CONFIG_OUTPUT 4 LLVM_OBJ_ROOT)
  list(GET CONFIG_OUTPUT 5 MAIN_SRC_DIR)
  list(GET CONFIG_OUTPUT 6 LLVM_CONFIG_CMAKE_PATH)

  if(NOT MSVC_IDE)
    set(LLVM_ENABLE_ASSERTIONS ${ENABLE_ASSERTIONS}
      CACHE BOOL "Enable assertions")
    # Assertions should follow llvm-config's.
    mark_as_advanced(LLVM_ENABLE_ASSERTIONS)
  endif()

  set(LLVM_TOOLS_BINARY_DIR ${TOOLS_BINARY_DIR} CACHE PATH "Path to llvm/bin")
  set(LLVM_LIBRARY_DIR ${LIBRARY_DIR} CACHE PATH "Path to llvm/lib")
  set(LLVM_MAIN_INCLUDE_DIR ${INCLUDE_DIR} CACHE PATH "Path to llvm/include")
  set(LLVM_BINARY_DIR ${LLVM_OBJ_ROOT} CACHE PATH "Path to LLVM build tree")
  set(LLVM_MAIN_SRC_DIR ${MAIN_SRC_DIR} CACHE PATH "Path to LLVM source tree")

  # Normalize LLVM_CMAKE_PATH. --cmakedir might contain backslashes.
  # CMake assumes slashes as PATH.
  file(TO_CMAKE_PATH ${LLVM_CONFIG_CMAKE_PATH} LLVM_CMAKE_PATH)

  find_program(LLVM_TABLEGEN_EXE "llvm-tblgen" ${LLVM_TOOLS_BINARY_DIR}
    NO_DEFAULT_PATH)

  set(LLVMCONFIG_FILE "${LLVM_CMAKE_PATH}/LLVMConfig.cmake")
  if(EXISTS ${LLVMCONFIG_FILE})
    list(APPEND CMAKE_MODULE_PATH "${LLVM_CMAKE_PATH}")
    include(${LLVMCONFIG_FILE})
  else()
    message(FATAL_ERROR "Not found: ${LLVMCONFIG_FILE}")
  endif()

  # They are used as destination of target generators.
  # We try to keep these locations consistent with the builtin_llvm. This is important
  # for the LLVMRES target.
  # FIXME: In longer term, we do not really need this and may want to adjust LLVMRES.

=== main/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT main package
# @author Pere Mato, CERN
############################################################################

if(NOT WIN32)
  ROOT_EXECUTABLE(rootn.exe rmain.cxx LIBRARIES New Core MathCore Rint)
  if(ROOT_PLATFORM MATCHES linux)
    SET_TARGET_PROPERTIES(rootn.exe PROPERTIES LINK_FLAGS "-Wl,--no-as-needed")
  endif()
  ROOT_EXECUTABLE(roots.exe roots.cxx LIBRARIES Core MathCore)
  ROOT_EXECUTABLE(xpdtest xpdtest.cxx LIBRARIES Proof Tree Hist RIO Net Thread Matrix MathCore)
endif()
ROOT_EXECUTABLE(root.exe rmain.cxx LIBRARIES Core Rint)
if(MSVC)
  set(root_exports "/EXPORT:_Init_thread_abort /EXPORT:_Init_thread_epoch
      /EXPORT:_Init_thread_footer /EXPORT:_Init_thread_header /EXPORT:_tls_index
      /STACK:4000000")
  set_property(TARGET root.exe APPEND_STRING PROPERTY LINK_FLAGS ${root_exports})
endif()
ROOT_EXECUTABLE(proofserv.exe pmain.cxx LIBRARIES Core MathCore)
if(MSVC)
  ROOT_EXECUTABLE(hadd hadd.cxx LIBRARIES Core RIO Net Hist Graf Graf3d Gpad Tree Matrix MathCore)
else()
  ROOT_EXECUTABLE(hadd hadd.cxx LIBRARIES Core RIO Net Hist Graf Graf3d Gpad Tree Matrix MathCore MultiProc)
endif()
ROOT_EXECUTABLE(rootnb.exe nbmain.cxx LIBRARIES Core)

if(fortran AND CMAKE_Fortran_COMPILER)
  ROOT_EXECUTABLE(g2root g2root.f LIBRARIES minicern)
  set_target_properties(g2root PROPERTIES COMPILE_FLAGS "-w")
  ROOT_EXECUTABLE(h2root h2root.cxx LIBRARIES Core RIO Net Hist Graf Graf3d Gpad Tree Matrix MathCore Thread minicern)
endif()

if(python)
  file(GLOB utils RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} python/root*)
  foreach(rawUtilName ${utils})
    get_filename_component(utilName ${rawUtilName} NAME)
    if(NOT WIN32)
      # We need the .py only on Windows
      string(REPLACE ".py" "" utilName ${utilName})
    endif()
    get_filename_component(python ${PYTHON_EXECUTABLE} NAME)
    configure_file(${rawUtilName} ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}/${utilName} @ONLY)

    install(FILES ${CMAKE_BINARY_DIR}/${CMAKE_INSTALL_BINDIR}/${utilName}
                                 DESTINATION ${CMAKE_INSTALL_BINDIR} 
                                 RENAME ${utilName}
                                 PERMISSIONS OWNER_EXECUTE OWNER_WRITE OWNER_READ
                                             GROUP_EXECUTE GROUP_READ
                                             WORLD_EXECUTE WORLD_READ 
                                 COMPONENT applications)
  endforeach()

  install(FILES python/cmdLineUtils.py DESTINATION ${runtimedir})
  if(IS_ABSOLUTE ${runtimedir})
    set(absruntimedir ${runtimedir})
  else()
    set(absruntimedir \${CMAKE_INSTALL_PREFIX}/${runtimedir})
  endif()
  install(CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} -m py_compile \$ENV{DESTDIR}${absruntimedir}/cmdLineUtils.py)")
  install(CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} -O -m py_compile \$ENV{DESTDIR}${absruntimedir}/cmdLineUtils.py)")
  configure_file(python/cmdLineUtils.py ${localruntimedir}/cmdLineUtils.py @ONLY)
endif()


if(NOT MSVC)
  set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CLING_CXXFLAGS} -Wno-unused-parameter")
else()
  set_source_files_properties(src/rootcling.cxx PROPERTIES COMPILE_FLAGS "-DNOMINMAX -D_XKEYCHECK_H")
endif()

ROOT_EXECUTABLE(rootcling src/rootcling.cxx
                          LIBRARIES RIO Core Cling ${PCRE_LIBRARIES} ${LZMA_LIBRARIES} ZLIB::ZLIB
                                    ${CMAKE_DL_LIBS} ${CMAKE_THREAD_LIBS_INIT}
                                    ${corelinklibs})
# rootcling includes the ROOT complex header which would build the complex
# dictionary with modules. To make sure that rootcling_stage1 builds this
# dict before we use it, we add a dependency here.
add_dependencies(rootcling complexDict)

target_include_directories(rootcling PRIVATE
        ${CMAKE_CURRENT_SOURCE_DIR}/../core/metacling/res
        ${CMAKE_CURRENT_SOURCE_DIR}/../core/dictgen/res
        ${CMAKE_CURRENT_SOURCE_DIR}/../io/rootpcm/res)
if(WIN32)
  set_target_properties(rootcling PROPERTIES WINDOWS_EXPORT_ALL_SYMBOLS 1)
endif()

# Create aliases: rootcint, genreflex.
if(WIN32)
  add_custom_command(TARGET rootcling POST_BUILD
                     COMMAND copy /y rootcling.exe rootcint.exe
                     COMMAND copy /y rootcling.exe genreflex.exe
                     WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
else()
  add_custom_command(TARGET rootcling POST_BUILD
                     COMMAND ln -f rootcling rootcint
                     COMMAND ln -f rootcling genreflex
                     WORKING_DIRECTORY ${CMAKE_RUNTIME_OUTPUT_DIRECTORY})
endif()
set_directory_properties(PROPERTIES ADDITIONAL_MAKE_CLEAN_FILES
                         "${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/rootcint;${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/genreflex")

if(CMAKE_HOST_UNIX)
  install(CODE "execute_process(COMMAND ln -f rootcling rootcint WORKING_DIRECTORY \$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR})" COMPONENT applications)
  install(CODE "execute_process(COMMAND ln -f rootcling genreflex WORKING_DIRECTORY \$ENV{DESTDIR}\${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_BINDIR})" COMPONENT applications)
else()
  if(MSVC)
    install(PROGRAMS  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/rootcling.exe DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT applications)
    install(PROGRAMS  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/rootcint.exe DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT applications)
    install(PROGRAMS  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/genreflex.exe DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT applications)
  else()
    install(PROGRAMS  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/rootcint
                      ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/genreflex
                      ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/rlibmap
                      DESTINATION ${CMAKE_INSTALL_BINDIR} COMPONENT applications)
  endif()
endif()

=== net/CMakeLists.txt ===
add_subdirectory(net)
add_subdirectory(auth)

if(afs)
  add_subdirectory(afs)
endif()

if(bonjour)
  add_subdirectory(bonjour)
endif()

if(krb5)
  add_subdirectory(krb5auth)
endif()

if(NOT WIN32 AND ssl)
  add_subdirectory(rpdutils)
endif()

if(xrootd)
  add_subdirectory(netx)
endif()

if(alien)
  add_subdirectory(alien)
endif()

if(monalisa)
  add_subdirectory(monalisa)
endif()

if(ldap)
   add_subdirectory(ldap)
endif()

if(globus)
   add_subdirectory(globusauth)
endif()

if(davix)
   add_subdirectory(davix)
endif()

if(netxng)
   add_subdirectory(netxng)
endif()

if(http)
   add_subdirectory(http)
   add_subdirectory(httpsniff)
endif()

=== roofit/CMakeLists.txt ===
add_subdirectory(roofitcore)
add_subdirectory(roofit)
add_subdirectory(roostats)
if(xml OR ROOT_xml_FOUND)
  add_subdirectory(histfactory)
endif()

=== tree/CMakeLists.txt ===
add_subdirectory(tree)
add_subdirectory(treeplayer)
add_subdirectory(treeviewer)
add_subdirectory(dataframe)

=== bindings/pyroot/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT bindings/pyroot package
############################################################################

ROOT_STANDARD_LIBRARY_PACKAGE(PyROOT
  NO_INSTALL_HEADERS
  HEADERS
    TPyArg.h
    TPyDispatcher.h
    TPyException.h
    TPyFitFunction.h
    TPyReturn.h
    TPyROOTApplication.h
    TPySelector.h
    TPython.h
  SOURCES
    src/Converters.cxx
    src/Cppyy.cxx
    src/Executors.cxx
    src/MethodProxy.cxx
    src/ObjectProxy.cxx
    src/PropertyProxy.cxx
    src/PyRootType.cxx
    src/PyStrings.cxx
    src/Pythonize.cxx
    src/RootModule.cxx
    src/RootWrapper.cxx
    src/TCallContext.cxx
    src/TClassMethodHolder.cxx
    src/TConstructorHolder.cxx
    src/TCustomPyTypes.cxx
    src/TemplateProxy.cxx
    src/TFunctionHolder.cxx
    src/TMemoryRegulator.cxx
    src/TMethodHolder.cxx
    src/TPyArg.cxx
    src/TPyBufferFactory.cxx
    src/TPyClassGenerator.cxx
    src/TPyDispatcher.cxx
    src/TPyException.cxx
    src/TPyFitFunction.cxx
    src/TPyReturn.cxx
    src/TPyROOTApplication.cxx
    src/TPySelector.cxx
    src/TPython.cxx
    src/TSetItemHolder.cxx
    src/TTupleOfInstances.cxx
    src/Utility.cxx
  DICTIONARY_OPTIONS
    -writeEmptyRootPCM
  DEPENDENCIES
    Core
    MathCore
    ROOTVecOps
    Tree
)

ROOT_ADD_CXX_FLAG(_PyROOT_FLAGS -fno-strict-aliasing)
ROOT_ADD_CXX_FLAG(_PyROOT_FLAGS -Wno-parentheses-equality)
ROOT_ADD_CXX_FLAG(_PyROOT_FLAGS -Wno-cast-function-type)
ROOT_ADD_CXX_FLAG(_PyROOT_FLAGS -Wno-deprecated-register)
ROOT_ADD_CXX_FLAG(_PyROOT_FLAGS -Wno-register)

separate_arguments(_PyROOT_FLAGS)

target_compile_options(PyROOT PRIVATE ${_PyROOT_FLAGS})
target_link_libraries(PyROOT PRIVATE ${PYTHON_LIBRARIES})
target_include_directories(PyROOT PRIVATE ${PYTHON_INCLUDE_DIRS})

ROOT_LINKER_LIBRARY(JupyROOT JupyROOT/src/IOHandler.cxx DEPENDENCIES Core CMAKENOEXPORT)

if(MSVC)
  if(${PYTHON_VERSION_MAJOR} GREATER_EQUAL 3)
    set(init_symbol PyInit_libPyROOT)
  else()
    set(init_symbol initlibPyROOT)
  endif()
  add_custom_command(TARGET PyROOT POST_BUILD
                     COMMAND link -dll -nologo -IGNORE:4001 -machine:ix86 -export:${init_symbol}
                     $<TARGET_LINKER_FILE:PyROOT> msvcrt.lib
                     -out:$<TARGET_FILE_DIR:PyROOT>/libPyROOT.pyd)
  install(FILES  ${CMAKE_RUNTIME_OUTPUT_DIRECTORY}/libPyROOT.pyd
                 DESTINATION ${CMAKE_INSTALL_BINDIR}
                 COMPONENT libraries)
endif()

#---Install python modules--------------------------------------------------
file(GLOB pyfiles RELATIVE ${CMAKE_CURRENT_SOURCE_DIR} *.py)
foreach(pyfile ${pyfiles})
  install(FILES ${pyfile} DESTINATION ${runtimedir})
  if(IS_ABSOLUTE ${runtimedir})
    set(absruntimedir ${runtimedir})
  else()
    set(absruntimedir \${CMAKE_INSTALL_PREFIX}/${runtimedir})
  endif()
  install(CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} -m py_compile \$ENV{DESTDIR}${absruntimedir}/${pyfile})")
  install(CODE "execute_process(COMMAND ${PYTHON_EXECUTABLE} -O -m py_compile \$ENV{DESTDIR}${absruntimedir}/${pyfile})")
  file(COPY ${pyfile} DESTINATION ${localruntimedir})
endforeach()

set(JupyROOTDirName "JupyROOT")
install (DIRECTORY ${JupyROOTDirName} DESTINATION ${runtimedir})
file(COPY ${JupyROOTDirName} DESTINATION ${localruntimedir})

set( JsMVADirName "JsMVA")
install (DIRECTORY ${JsMVADirName} DESTINATION ${runtimedir})
file(COPY ${JsMVADirName} DESTINATION ${localruntimedir})

ROOT_INSTALL_HEADERS()

ROOT_ADD_TEST_SUBDIRECTORY(test)

=== bindings/ruby/CMakeLists.txt ===
############################################################################
# CMakeLists.txt file for building ROOT bindings/ruby package
############################################################################
include_directories(${RUBY_INCLUDE_DIRS})

ROOT_STANDARD_LIBRARY_PACKAGE(Ruby
                              LIBRARIES ${RUBY_LIBRARY} ${CMAKE_DL_LIBS}
                              DEPENDENCIES Hist MathCore)

=== build/package/debian/control ===
Source: root-system
Section: science
Priority: optional
Maintainer: Antonio Salvucci <s4lb04@gmail.com>
Homepage: http://root.cern.ch
Build-Depends: debhelper (>= 5.0.37.2), po-debconf, libssl-dev, comerr-dev, libxpm-dev, x11proto-xext-dev, libxext-dev, libfreetype6-dev, libpcre3-dev, zlib1g-dev | libz-dev, python-dev (>= 2.1), graphviz, ttf-freefont, libncurses5-dev | libcurses-dev, libgraphviz-dev, libxft-dev, python-support (>= 0.3), ruby (>= 1.8), ruby1.8-dev | ruby-dev (>= 1.8), libglu1-mesa-dev | libglu1-xorg-dev | xlibmesa-glu-dev |  libglu-dev, libglew1.5-dev | libglew-dev, libftgl-dev | ftgl-dev, libxml2-dev, libgsl0-dev, libldap2-dev | libldap-dev, libavahi-compat-libdnssd-dev, libxmlrpc-c3-dev | libxmlrpc-c-dev, libcurl4-gnutls-dev | libcurl4-openssl-dev | libcurl-dev, libjpeg62-dev, libpng12-dev, libtiff4-dev, libgif-dev | libungif4-dev, libxinerama-dev, libfftw3-dev | fftw3-dev, libglobus-gss-assist-dev, libglobus-gssapi-gsi-dev, libglobus-gsi-credential-dev, libglobus-common-dev, libglobus-gsi-callback-dev, libglobus-gsi-sysconfig-dev, libglobus-gssapi-gsi-dev, libglobus-gsi-callback-dev, libglobus-gsi-cert-utils-dev, libglobus-openssl-dev, libglobus-gsi-proxy-core-dev, libglobus-callout-dev, globus-proxy-utils,krb5-user|heimdal-clients, libmysqlclient15-dev | libmysqlclient14-dev| libmysqlclient12-dev| libmysqlclient-dev, libiodbc2-dev | unixodbc-dev,  libpq-dev | postgresql-dev, gfortran|fortran-compiler, libqt4-dev (>= 4.3.0) | libqt3-mt-dev (>= 3.3.0), qt4-dev-tools (>= 4.3.0) | qt3-dev-tools (>= 3.3.0), libqt4-opengl-dev, libkrb5-dev|heimdal-dev
Standards-Version: 3.8.3

Package: root-system
Architecture: all
Depends: root-system-bin, libroot-core-dev, ${misc:Depends}
Recommends: libroot-graf3d-gl-dev (>= ${binary:Version}), libroot-io-xmlparser-dev (>= ${binary:Version}), libroot-math-mathmore-dev (>= ${binary:Version}), libroot-math-unuran-dev (>= ${binary:Version}), libroot-misc-table-dev (>= ${binary:Version}), libroot-net-ldap-dev (>= ${binary:Version}), libroot-net-bonjour-dev (>= ${binary:Version}), root-plugin-graf2d-asimage (>= ${binary:Version}), root-plugin-gui-qt (>= ${binary:Version}), root-plugin-graf2d-qt (>= ${binary:Version}), root-plugin-math-fftw3 (>= ${binary:Version}), root-plugin-math-minuit2 (>= ${binary:Version}), root-plugin-net-krb5 (>= ${binary:Version}), root-plugin-sql-odbc (>= ${binary:Version}), root-system-xrootd (>= ${binary:Version}), root-plugin-net-netx (>= ${binary:Version}), root-plugin-net-xrootd (>= ${binary:Version}), libroot-geom-dev (>= ${binary:Version}), libroot-graf2d-gpad-dev (>= ${binary:Version}), libroot-graf2d-graf-dev (>= ${binary:Version}), libroot-graf2d-postscript-dev (>= ${binary:Version}), libroot-graf3d-eve-dev (>= ${binary:Version}), libroot-graf3d-g3d-dev (>= ${binary:Version}), libroot-gui-dev (>= ${binary:Version}), libroot-gui-ged-dev (>= ${binary:Version}), libroot-hist-dev (>= ${binary:Version}), libroot-hist-spectrum-dev (>= ${binary:Version}), libroot-io-dev (>= ${binary:Version}), libroot-math-foam-dev (>= ${binary:Version}), libroot-math-genvector-dev (>= ${binary:Version}), libroot-math-mathcore-dev (>= ${binary:Version}), libroot-math-matrix-dev (>= ${binary:Version}), libroot-math-minuit-dev (>= ${binary:Version}), libroot-math-mlp-dev (>= ${binary:Version}), libroot-math-physics-dev (>= ${binary:Version}), libroot-math-quadp-dev (>= ${binary:Version}), libroot-math-smatrix-dev (>= ${binary:Version}), libroot-math-splot-dev (>= ${binary:Version}), libroot-misc-minicern-dev (>= ${binary:Version}), libroot-misc-memstat-dev (>= ${binary:Version}), libroot-montecarlo-eg-dev (>= ${binary:Version}), libroot-montecarlo-vmc-dev (>= ${binary:Version}), libroot-net-dev (>= ${binary:Version}), libroot-net-auth-dev (>= ${binary:Version}), libroot-proof-dev (>= ${binary:Version}), libroot-proof-proofplayer-dev (>= ${binary:Version}), libroot-tmva-dev (>= ${binary:Version}), libroot-tree-dev (>= ${binary:Version}), libroot-tree-treeplayer-dev (>= ${binary:Version}), root-plugin-geom-geombuilder (>= ${binary:Version}), root-plugin-geom-geompainter (>= ${binary:Version}), root-plugin-graf2d-x11 (>= ${binary:Version}), root-plugin-graf3d-x3d (>= ${binary:Version}), root-plugin-gui-fitpanel (>= ${binary:Version}), root-plugin-gui-guibuilder (>= ${binary:Version}), root-plugin-gui-sessionviewer (>= ${binary:Version}), root-plugin-hist-hbook (>= ${binary:Version}), root-plugin-hist-histpainter (>= ${binary:Version}), root-plugin-hist-spectrumpainter (>= ${binary:Version}), root-plugin-io-sql (>= ${binary:Version}), root-plugin-io-xml (>= ${binary:Version}), root-plugin-math-fumili (>= ${binary:Version}), root-plugin-proof-xproof (>= ${binary:Version}), root-plugin-tree-treeviewer (>= ${binary:Version}), root-system-doc  (>= ${binary:Version})
Suggests: libroot-bindings-python-dev (>= ${binary:Version}), libroot-bindings-ruby-dev (>= ${binary:Version}), libroot-proof-clarens-dev (>= ${binary:Version}), libroot-roofit-dev (>= ${binary:Version}), root-plugin-geom-gdml (>= ${binary:Version}), root-plugin-net-globus (>= ${binary:Version}), root-plugin-proof-peac (>= ${binary:Version}), root-plugin-sql-mysql (>= ${binary:Version}), root-plugin-sql-pgsql (>= ${binary:Version})
Description: metapackage to install all ROOT packages
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently.
 .
 With the data defined as a set of objects, specialized storage methods
 can give direct access to the separate attributes of the selected
 objects, without having to touch the bulk of the data. Included are
 histogramming methods in 1, 2 and 3 dimensions, curve fitting, function
 evaluation, minimization, graphics and visualization classes to allow the
 easy creation of an analysis system that can query and process the data
 interactively or in batch mode.
 .
 The command language, the scripting (or macro) language, and the   
 programming language are all C++, thanks to the built-in CINT C++    
 interpreter. This interpreter removes the time consuming compile/link
 cycle, allowing for fast prototyping of the macros, and providing a
 good environment to learn C++. If more performance is needed, the
 interactively developed macros can be compiled using a C++ compiler.
 .
 The system has been designed in such a way that it can query its
 databases in parallel on MPP machines or on clusters of workstations
 or high-end PCs. ROOT is an open system that can be dynamically
 extended by linking external libraries. This makes ROOT a premier
 platform on which to build data acquisition, simulation and data
 analysis systems.
 .
 This package is a metapackage to ensure the installation of all
 possible ROOT packages on a system. 
 

Package: libroot-bindings-python5.24
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${python:Depends}, ${misc:Depends} 
Replaces: root-plugin-python  (<< 5.09.01-1)
Description: Python extension for ROOT - runtime libraries 
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Python plug-in for ROOT.  This package
 provide a Python interface to ROOT, and a ROOT interface to Python.

Package: libroot-bindings-python-dev
Architecture: any
Section: libdevel
Depends: libroot-bindings-python5.24 (= ${binary:Version}), libroot-core-dev, python-dev (>= 2.1), ${python:Depends}, ${misc:Depends} 
Provides: ${python:Provides}
Replaces: libroot-python-dev
Conflicts: libroot-python-dev (<< 5.19.01-1)
Description: Python extension for ROOT - development files 
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Python plug-in for ROOT.  This package
 provide a Python interface to ROOT, and a ROOT interface to Python.

Package: libroot-bindings-ruby5.24
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends} 
Replaces: root-plugin-ruby  (<< 5.09.01-1)
Description: Ruby extension for ROOT - run-time library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Ruby extension for ROOT.  The interface
 goes both ways - that is, you can call ROOT functions from Ruby, and
 invoke the Ruby interpreter from ROOT. 

Package: libroot-bindings-ruby-dev
Architecture: any
Section: libdevel
Depends: libroot-bindings-ruby5.24 (= ${binary:Version}), libroot-core-dev, ruby1.8-dev | ruby-dev (>= 1.8), ${misc:Depends} 
Conflicts: libroot-ruby (<< 5.19.01-1)
Replaces: libroot-ruby
Description: Ruby extension for ROOT - development headers
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the Ruby extension for ROOT.

Package: libroot-graf3d-gl5.24
Architecture: any
Section: libs
Depends: ${shlibs:Depends}, ${misc:Depends}
Conflicts: root-plugin-graf3d-gl (<< 5.19.00-1)
Replaces: root-plugin-graf3d-gl (<< 5.19.00-1)
Provides: root-plugin-graf3d-gl
Description: GL plugin for ROOT - runtime library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the GL plug-in for ROOT.  This plugin provides
 3D rendering of volumes and shapes defined in ROOT, as well as 3D 
 rendering of histograms, and similar.  Included is also a high quality 
 3D viewer for ROOT defined geometries.

Package: libroot-graf3d-gl-dev
Architecture: any
Section: libdevel
Depends: libroot-graf3d-gl5.24 (= ${binary:Version}), ${misc:Depends}
Conflicts: root-plugin-graf3d-gl (<< 5.19.00-1)
Replaces: root-plugin-graf3d-gl
Description: GL plugin for ROOT - development files
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the GL plug-in for ROOT.  This plugin provides
 3D rendering of volumes and shapes defined in ROOT.  Included is also
 a high quality 3D viewer for ROOT defined geometries.

Package: libroot-io-xmlparser5.24
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Input/output of ROOT objects - runtime library
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package provides I/O routines for ROOT objects. 

Package: libroot-io-xmlparser-dev
Architecture: any
Section: libdevel
Depends: libroot-io-xmlparser5.24 (= ${binary:Version}), libroot-core-dev, ${misc:Depends}
Replaces: libroot-dev, root-plugin-xml
Conflicts: libroot-dev (<< 5.19.01-1), root-plugin-xml (<< 5.19.01-1)
Description: Input/output of ROOT objects - development files
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package provides I/O routines for ROOT objects. 

Package: libroot-math-mathmore5.24
Section: libs
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: GSL interface library for ROOT
 The ROOT system provides a set of OO frameworks with all the
 functionality needed to handle and analyze large amounts of data
 efficiently. 
 .
 This package contains the MathMore library for ROOT.  This provides 
 a partial GNU Scientific Library interface for ROOT.

Package: libroot-math-mathmore-dev
Architecture: any
Section: libdevel

=== build/package/debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
#
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.
#
# Modified to make a template file for a multi-binary package with separated
# build-arch and build-indep targets  by Bill Allombert 2001
#
# Last changes are made by Antonio Salvucci <s4lb04@gmail.com>

# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE    ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_HOST_ARCH_CPU    ?= $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
DEB_BUILD_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
DEB_BUILD_GNU_SYSTEM ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_SYSTEM)
DEB_BUILD_ARCH	     ?= $(shell dpkg-architecture -qDEB_BUILD_ARCH)
ifeq ($(DEB_HOST_ARCH_CPU),powerpc)
PLATFORM	= linux
else
PLATFORM	=
endif
ifneq (,$(findstring debug,$(DEB_BUILD_OPTIONS)))
BUILDOPT	= --build=debug
endif
ifeq (,$(findstring nostrip,$(DEB_BUILD_OPTIONS)))
INSTALL_PROGRAM = -s
endif
UNUR		= --enable-unuran
#ifneq (,$(findstring alpha, $(DEB_BUILD_ARCH)))
#UNUR		= --disable-unuran
#endif
XRD		= --enable-xrootd
#ifneq (,$(findstring sparc, $(DEB_BUILD_ARCH)))
#XRD		= --disable-xrootd
#endif

DTMP		= debian/tmp
PREFIX		= /usr
SYSCONFDIR	= /etc
PKGDOCDIR	= $(PREFIX)/share/doc/root
CINTDIR		= $(PREFIX)/lib/root/$(SOVERS)
ICONTHEME	= $(PREFIX)/share/icons/hicolor/48x48
CONFOPTIONS	:=--enable-bonjour				\
		  --enable-cintex				\
		  --enable-clarens				\
		  --enable-editline				\
		  --enable-explicitlink				\
		  --enable-gdml					\
		  --enable-globus				\
		  --enable-gsl-shared				\
		  --enable-gviz					\
		  --enable-fftw3				\
		  --enable-krb5					\
		  --enable-ldap					\
		  --enable-qt					\
		  --enable-qtgsi				\
		  --enable-mathcore				\
		  --enable-mathmore				\
		  --enable-minuit2				\
		  --enable-mysql				\
		  --enable-peac					\
		  --enable-pgsql				\
		  --enable-odbc					\
		  --enable-reflex				\
		  --enable-roofit				\
		  --enable-ruby					\
		  --enable-shadowpw				\
		  --enable-shared				\
		  --enable-soversion				\
		  --enable-table				\
		  --disable-rpath				\
		  --disable-afs					\
		  --disable-srp					\
		  --disable-builtin-afterimage			\
		  --disable-builtin-ftgl			\
		  --disable-builtin-freetype			\
		  --disable-builtin-glew			\
		  --disable-builtin-pcre			\
		  --disable-builtin-zlib			\
		  --disable-alien				\
		  --disable-chirp				\
		  --disable-dcache				\
		  --disable-gfal				\
		  --disable-monalisa				\
		  --disable-oracle				\
		  --disable-pythia6				\
		  --disable-rfio				\
		  --disable-sapdb				\
		  --fail-on-missing				\
		  --with-globus=/usr				\
		  --with-globus-incdir=/usr/include/globus	\
		  --with-globus-libdir=/usr/lib			\
		  $(UNUR)					\
		  $(XRD)					\
		  $(BUILDOPT)
#
# Things for the future 
#
#		  --enable-mathcore	libroot
#		  --enable-cintex	libroot
#		  --enable-reflex	libroot
#		  --with-globus=/opt/globus
#		  --disable-builtin-gsl				
#		  --disable-builtin				\

VERSION		:= $(shell cat build/version_number | tr '/' '.')
MAJOR		:= $(shell echo $(VERSION) | tr '.' ' ' | cut -f1 -d' ')
MINOR		:= $(shell echo $(VERSION) | tr '.' ' ' | cut -f2 -d' ')
SOVERS		:= $(MAJOR).$(MINOR)
PKGLIST		:= $(shell ./configure $(PLATFORM) --pkglist $(CONFOPTIONS) | sed -n -e 's/packages: //p')
ESSENTIALS	:= libroot-core-dev			\
		   libroot-core				\
		   root-system-bin			\
		   root-system-common			\
		   ttf-root-installer		
PLUGINS		:= libroot-geom				\
		   libroot-graf2d-gpad			\
		   libroot-graf2d-graf			\
		   libroot-graf2d-postscript		\
		   libroot-graf3d-eve			\
		   libroot-graf3d-g3d			\
		   libroot-graf3d-gl			\
		   libroot-gui				\
		   libroot-gui-ged			\
		   libroot-hist				\
		   libroot-hist-spectrum		\
		   libroot-io				\
		   libroot-io-xmlparser			\
		   libroot-math-foam			\
		   libroot-math-genvector		\
		   libroot-math-mathcore		\
		   libroot-math-mathmore		\
		   libroot-math-matrix			\
		   libroot-math-minuit			\
		   libroot-math-mlp			\
		   libroot-math-quadp			\
		   libroot-math-physics			\
		   libroot-math-smatrix			\
		   libroot-math-splot			\
		   libroot-math-unuran			\
		   libroot-misc-minicern		\
		   libroot-misc-memstat			\
		   libroot-misc-table			\
		   libroot-montecarlo-eg		\
		   libroot-montecarlo-vmc		\
		   libroot-net				\
		   libroot-net-auth			\
		   libroot-net-bonjour			\
		   libroot-net-ldap			\
		   libroot-proof			\
		   libroot-proof-proofplayer		\
		   libroot-tmva				\
		   libroot-tree				\
		   libroot-tree-treeplayer		\
		   root-plugin-geom-geombuilder		\
		   root-plugin-geom-geompainter		\
		   root-plugin-graf2d-asimage		\
		   root-plugin-graf2d-qt		\
		   root-plugin-graf2d-x11		\
		   root-plugin-graf2d-gvi		\
		   root-plugin-graf3d-x3d		\
		   root-plugin-gui-fitpanel		\
		   root-plugin-gui-guibuilder		\
		   root-plugin-gui-qt			\
		   root-plugin-gui-sessionviewer	\
		   root-plugin-hist-hbook		\
		   root-plugin-hist-histpainter		\
		   root-plugin-hist-spectrumpainter	\
		   root-plugin-io-sql			\
		   root-plugin-io-xml			\
		   root-plugin-math-fftw3		\
		   root-plugin-math-fumili		\
		   root-plugin-math-minuit2		\
		   root-plugin-net-krb5			\
		   root-plugin-net-netx			\
		   root-plugin-net-xrootd		\
		   root-plugin-proof-xproof		\
		   root-plugin-sql-odbc			\
		   root-plugin-tree-treeviewer		\
		   root-system-doc			\
		   root-system-xrootd		
EXTRAS		:= libroot-proof-clarens		\
		   libroot-bindings-python		\
		   libroot-roofit			\
		   libroot-bindings-ruby		\
		   root-plugin-geom-gdml		\
		   root-plugin-io-castor		\
		   root-plugin-io-chirp			\
		   root-plugin-io-dcache		\
		   root-plugin-montecarlo-pythia8	\
		   root-plugin-net-globus		\
		   root-plugin-net-bonjour		\
		   root-plugin-net-alien		\
		   root-plugin-net-srp			\
		   root-plugin-proof-peac		\
		   root-plugin-sql-maxdb		\
		   root-plugin-sql-mysql		\
		   root-plugin-sql-oracle		\
		   root-plugin-sql-pgsql		
PLUGINLIST	:= $(filter-out $(EXTRAS) $(ESSENTIALS), $(PKGLIST))
EXTRALIST	:= $(filter-out $(PLUGINS) $(ESSENTIALS), $(PKGLIST))
PLUGINLIST	:= $(PLUGINLIST:libroot%=libroot%-dev)
EXTRALIST	:= $(EXTRALIST:libroot%=libroot%-dev)
PLUGINHEAD	:= $(filter-out $(lastword $(PLUGINLIST)), $(PLUGINLIST))
PLUGINLIST	:= $(PLUGINHEAD:%=%,) $(lastword $(PLUGINLIST))
EXTRAHEAD	:= $(filter-out $(lastword $(EXTRALIST)), $(EXTRALIST))
EXTRALIST	:= $(EXTRAHEAD:%=%,) $(lastword $(EXTRALIST))
TEMPLATES	:= $(wildcard debian/*.in)
SPKGLIST	:= $(filter-out root-system-doc root-system-common ttf-root-installer, $(PKGLIST:libroot%=libroot%$(SOVERS))) $(filter libroot%, $(PKGLIST:libroot%=libroot%-dev)) libroot-static
IPKGLIST	:= root-system-doc ttf-root-installer root-system-common root-system
DPKGLIST	:= $(SPKGLIST:%=%,) root-system-doc, root-ttf
#root-plugins root-extra-plugins
SPKGOPTS	:= $(SPKGLIST:%=-p%) 
IPKGOPTS	:= $(IPKGLIST:%=-p%) 
PKGOPTS		:= $(IPKGOPTS) $(SPKGOPTS)
HAVERUBY	:= $(filter libroot-bindings-ruby, $(PKGLIST))
ifeq ($(HAVERUBY), libroot-bindings-ruby)
RUBYARCHDIR	:= $(shell ruby -rrbconfig -e 'puts Config::CONFIG["archdir"]' | sed 's,/,,')
else
RUBYARCHDIR	:= 
endif
HAVEPYTHON	:= $(filter libroot-bindings-python, $(PKGLIST))
ifeq ($(HAVEPYTHON), libroot-bindings-python)
PYVERS		:= $(shell pyversions -vs)
PYVER		:= $(shell python -c 'import sys; print "%d.%d" % (sys.version_info[0], sys.version_info[1])')
PYTHONDIR	:= /usr/lib/python-support/root/python$(PYVER)
else
PYTHONDIR	:= 
endif

# This has to be exported to make some magic below work.
export DH_OPTIONS

show_pkgs:
	@printf "SPKGLIST:\n $(foreach i, $(SPKGLIST), \t$(i)\n)"
